#include <stdio.h>

/**
 * 位运算加法
 * 就和我们算十位加法差不多
 * 10+1=11
 * 11+1=100
 * 11+11=0
 * 画个式子
 * 010   0011   0011
 * +01   +001   +011
 * ----  --``-  -``-
 * 011   0100   0110
 * 
 * 位运算中,^(位异或)相当于加法,但是不会进位
 * &(位与)判断进位,然后<<(左移)动一位
 * 例如11+11可以解析成下面这样
 * 11^11=00
 * (11&11)<<1=110
 * 完整例子2:101+11
 * 101^11=110
 * (101&11)<<1=010
 * 重复
 * 110^010=100
 * (110&010)<<1=100
 * 重复
 * 100^100=0
 * 100&100<<1=1000
 * 重复
 * 0^1000=1000
 * 0&1000<<1=0
 * 结束,返回1000
 */

int bit_add(int num1, int num2)
{
    while (num2)
    {
        int tmp = num1 ^ num2;
        num2 = (num1 & num2) << 1;
        num1 = tmp;
    }
    return num1;
}

int main()
{
    printf("%d\n", bit_add(32, 1));
    getchar();
    return 0;
}